// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: settlement.proto
// </auto-generated>
#pragma warning disable 0414, 1591
#region Designer generated code

using grpc = global::Grpc.Core;

namespace Settlement {
  public static partial class SettlementServices
  {
    static readonly string __ServiceName = "settlement.SettlementServices";

    static void __Helper_SerializeMessage(global::Google.Protobuf.IMessage message, grpc::SerializationContext context)
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (message is global::Google.Protobuf.IBufferMessage)
      {
        context.SetPayloadLength(message.CalculateSize());
        global::Google.Protobuf.MessageExtensions.WriteTo(message, context.GetBufferWriter());
        context.Complete();
        return;
      }
      #endif
      context.Complete(global::Google.Protobuf.MessageExtensions.ToByteArray(message));
    }

    static class __Helper_MessageCache<T>
    {
      public static readonly bool IsBufferMessage = global::System.Reflection.IntrospectionExtensions.GetTypeInfo(typeof(global::Google.Protobuf.IBufferMessage)).IsAssignableFrom(typeof(T));
    }

    static T __Helper_DeserializeMessage<T>(grpc::DeserializationContext context, global::Google.Protobuf.MessageParser<T> parser) where T : global::Google.Protobuf.IMessage<T>
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (__Helper_MessageCache<T>.IsBufferMessage)
      {
        return parser.ParseFrom(context.PayloadAsReadOnlySequence());
      }
      #endif
      return parser.ParseFrom(context.PayloadAsNewBuffer());
    }

    static readonly grpc::Marshaller<global::Settlement.Settlement> __Marshaller_settlement_Settlement = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Settlement.Settlement.Parser));
    static readonly grpc::Marshaller<global::Common.SettlementId> __Marshaller_common_SettlementId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.SettlementId.Parser));
    static readonly grpc::Marshaller<global::Common.UserId> __Marshaller_common_UserId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.UserId.Parser));
    static readonly grpc::Marshaller<global::Settlement.SettlementList> __Marshaller_settlement_SettlementList = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Settlement.SettlementList.Parser));
    static readonly grpc::Marshaller<global::Common.ResponseStatus> __Marshaller_common_ResponseStatus = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.ResponseStatus.Parser));
    static readonly grpc::Marshaller<global::Settlement.BuildBuildingCall> __Marshaller_settlement_BuildBuildingCall = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Settlement.BuildBuildingCall.Parser));
    static readonly grpc::Marshaller<global::Settlement.UpgradeBuildingCall> __Marshaller_settlement_UpgradeBuildingCall = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Settlement.UpgradeBuildingCall.Parser));

    static readonly grpc::Method<global::Settlement.Settlement, global::Settlement.Settlement> __Method_AddSettlement = new grpc::Method<global::Settlement.Settlement, global::Settlement.Settlement>(
        grpc::MethodType.Unary,
        __ServiceName,
        "AddSettlement",
        __Marshaller_settlement_Settlement,
        __Marshaller_settlement_Settlement);

    static readonly grpc::Method<global::Settlement.Settlement, global::Settlement.Settlement> __Method_AddTestSettlement = new grpc::Method<global::Settlement.Settlement, global::Settlement.Settlement>(
        grpc::MethodType.Unary,
        __ServiceName,
        "AddTestSettlement",
        __Marshaller_settlement_Settlement,
        __Marshaller_settlement_Settlement);

    static readonly grpc::Method<global::Common.SettlementId, global::Settlement.Settlement> __Method_GetSettlementByID = new grpc::Method<global::Common.SettlementId, global::Settlement.Settlement>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetSettlementByID",
        __Marshaller_common_SettlementId,
        __Marshaller_settlement_Settlement);

    static readonly grpc::Method<global::Common.UserId, global::Settlement.SettlementList> __Method_GetSettlementsByUserID = new grpc::Method<global::Common.UserId, global::Settlement.SettlementList>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetSettlementsByUserID",
        __Marshaller_common_UserId,
        __Marshaller_settlement_SettlementList);

    static readonly grpc::Method<global::Common.SettlementId, global::Common.ResponseStatus> __Method_DeleteSettlement = new grpc::Method<global::Common.SettlementId, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "DeleteSettlement",
        __Marshaller_common_SettlementId,
        __Marshaller_common_ResponseStatus);

    static readonly grpc::Method<global::Settlement.BuildBuildingCall, global::Common.ResponseStatus> __Method_BuildBuilding = new grpc::Method<global::Settlement.BuildBuildingCall, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "BuildBuilding",
        __Marshaller_settlement_BuildBuildingCall,
        __Marshaller_common_ResponseStatus);

    static readonly grpc::Method<global::Settlement.UpgradeBuildingCall, global::Common.ResponseStatus> __Method_UpgradeBuilding = new grpc::Method<global::Settlement.UpgradeBuildingCall, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "UpgradeBuilding",
        __Marshaller_settlement_UpgradeBuildingCall,
        __Marshaller_common_ResponseStatus);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Settlement.SettlementReflection.Descriptor.Services[0]; }
    }

    /// <summary>Base class for server-side implementations of SettlementServices</summary>
    [grpc::BindServiceMethod(typeof(SettlementServices), "BindService")]
    public abstract partial class SettlementServicesBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Settlement.Settlement> AddSettlement(global::Settlement.Settlement request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Settlement.Settlement> AddTestSettlement(global::Settlement.Settlement request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Settlement.Settlement> GetSettlementByID(global::Common.SettlementId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Settlement.SettlementList> GetSettlementsByUserID(global::Common.UserId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> DeleteSettlement(global::Common.SettlementId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> BuildBuilding(global::Settlement.BuildBuildingCall request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> UpgradeBuilding(global::Settlement.UpgradeBuildingCall request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for SettlementServices</summary>
    public partial class SettlementServicesClient : grpc::ClientBase<SettlementServicesClient>
    {
      /// <summary>Creates a new client for SettlementServices</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public SettlementServicesClient(grpc::ChannelBase channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for SettlementServices that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public SettlementServicesClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected SettlementServicesClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected SettlementServicesClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Settlement.Settlement AddSettlement(global::Settlement.Settlement request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddSettlement(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Settlement.Settlement AddSettlement(global::Settlement.Settlement request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_AddSettlement, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.Settlement> AddSettlementAsync(global::Settlement.Settlement request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddSettlementAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.Settlement> AddSettlementAsync(global::Settlement.Settlement request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_AddSettlement, null, options, request);
      }
      public virtual global::Settlement.Settlement AddTestSettlement(global::Settlement.Settlement request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddTestSettlement(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Settlement.Settlement AddTestSettlement(global::Settlement.Settlement request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_AddTestSettlement, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.Settlement> AddTestSettlementAsync(global::Settlement.Settlement request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddTestSettlementAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.Settlement> AddTestSettlementAsync(global::Settlement.Settlement request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_AddTestSettlement, null, options, request);
      }
      public virtual global::Settlement.Settlement GetSettlementByID(global::Common.SettlementId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetSettlementByID(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Settlement.Settlement GetSettlementByID(global::Common.SettlementId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetSettlementByID, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.Settlement> GetSettlementByIDAsync(global::Common.SettlementId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetSettlementByIDAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.Settlement> GetSettlementByIDAsync(global::Common.SettlementId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetSettlementByID, null, options, request);
      }
      public virtual global::Settlement.SettlementList GetSettlementsByUserID(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetSettlementsByUserID(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Settlement.SettlementList GetSettlementsByUserID(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetSettlementsByUserID, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.SettlementList> GetSettlementsByUserIDAsync(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetSettlementsByUserIDAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Settlement.SettlementList> GetSettlementsByUserIDAsync(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetSettlementsByUserID, null, options, request);
      }
      public virtual global::Common.ResponseStatus DeleteSettlement(global::Common.SettlementId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return DeleteSettlement(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus DeleteSettlement(global::Common.SettlementId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_DeleteSettlement, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> DeleteSettlementAsync(global::Common.SettlementId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return DeleteSettlementAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> DeleteSettlementAsync(global::Common.SettlementId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_DeleteSettlement, null, options, request);
      }
      public virtual global::Common.ResponseStatus BuildBuilding(global::Settlement.BuildBuildingCall request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return BuildBuilding(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus BuildBuilding(global::Settlement.BuildBuildingCall request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_BuildBuilding, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> BuildBuildingAsync(global::Settlement.BuildBuildingCall request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return BuildBuildingAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> BuildBuildingAsync(global::Settlement.BuildBuildingCall request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_BuildBuilding, null, options, request);
      }
      public virtual global::Common.ResponseStatus UpgradeBuilding(global::Settlement.UpgradeBuildingCall request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return UpgradeBuilding(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus UpgradeBuilding(global::Settlement.UpgradeBuildingCall request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_UpgradeBuilding, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> UpgradeBuildingAsync(global::Settlement.UpgradeBuildingCall request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return UpgradeBuildingAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> UpgradeBuildingAsync(global::Settlement.UpgradeBuildingCall request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_UpgradeBuilding, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override SettlementServicesClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new SettlementServicesClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(SettlementServicesBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_AddSettlement, serviceImpl.AddSettlement)
          .AddMethod(__Method_AddTestSettlement, serviceImpl.AddTestSettlement)
          .AddMethod(__Method_GetSettlementByID, serviceImpl.GetSettlementByID)
          .AddMethod(__Method_GetSettlementsByUserID, serviceImpl.GetSettlementsByUserID)
          .AddMethod(__Method_DeleteSettlement, serviceImpl.DeleteSettlement)
          .AddMethod(__Method_BuildBuilding, serviceImpl.BuildBuilding)
          .AddMethod(__Method_UpgradeBuilding, serviceImpl.UpgradeBuilding).Build();
    }

    /// <summary>Register service method with a service binder with or without implementation. Useful when customizing the  service binding logic.
    /// Note: this method is part of an experimental API that can change or be removed without any prior notice.</summary>
    /// <param name="serviceBinder">Service methods will be bound by calling <c>AddMethod</c> on this object.</param>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static void BindService(grpc::ServiceBinderBase serviceBinder, SettlementServicesBase serviceImpl)
    {
      serviceBinder.AddMethod(__Method_AddSettlement, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Settlement.Settlement, global::Settlement.Settlement>(serviceImpl.AddSettlement));
      serviceBinder.AddMethod(__Method_AddTestSettlement, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Settlement.Settlement, global::Settlement.Settlement>(serviceImpl.AddTestSettlement));
      serviceBinder.AddMethod(__Method_GetSettlementByID, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.SettlementId, global::Settlement.Settlement>(serviceImpl.GetSettlementByID));
      serviceBinder.AddMethod(__Method_GetSettlementsByUserID, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.UserId, global::Settlement.SettlementList>(serviceImpl.GetSettlementsByUserID));
      serviceBinder.AddMethod(__Method_DeleteSettlement, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.SettlementId, global::Common.ResponseStatus>(serviceImpl.DeleteSettlement));
      serviceBinder.AddMethod(__Method_BuildBuilding, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Settlement.BuildBuildingCall, global::Common.ResponseStatus>(serviceImpl.BuildBuilding));
      serviceBinder.AddMethod(__Method_UpgradeBuilding, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Settlement.UpgradeBuildingCall, global::Common.ResponseStatus>(serviceImpl.UpgradeBuilding));
    }

  }
}
#endregion
